## scip 10.0.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

# INTERPROCEDURAL_OPTIMIZATION is enforced when enabled.
if(POLICY CMP0069)
   cmake_policy(SET CMP0069 NEW)
endif()

# option() honors normal variables.
if(POLICY CMP0077)
   cmake_policy(SET CMP0077 NEW)
endif()

# MSVC runtime library flags are selected by an abstraction.
if(POLICY CMP0091)
   cmake_policy(SET CMP0091 NEW)
endif()

# Avoid warnings about removed FindBoost.cmake until our minimum required version is >= 3.30.
if(POLICY CMP0167)
   cmake_policy(SET CMP0167 NEW)
endif()

include(GNUInstallDirs)

set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_DEBUG} ${CMAKE_C_FLAGS_RELEASE}")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_DEBUG} ${CMAKE_CXX_FLAGS_RELEASE}")

set(SCIP_VERSION_MAJOR 10)
set(SCIP_VERSION_MINOR 0)
set(SCIP_VERSION_PATCH 1)
set(SCIP_VERSION_API 156)

project(SCIP
    VERSION ${SCIP_VERSION_MAJOR}.${SCIP_VERSION_MINOR}.${SCIP_VERSION_PATCH}
    LANGUAGES CXX C
    DESCRIPTION "SCIP is currently one of the fastest non-commercial solvers for mixed integer programming (MIP) and mixed integer nonlinear programming (MINLP)"
    )

get_directory_property(hasParent PARENT_DIRECTORY)
if(hasParent)
  set(SCIPOptSuite_VERSION_MAJOR ${SCIP_VERSION_MAJOR} PARENT_SCOPE)
  set(SCIPOptSuite_VERSION_MINOR ${SCIP_VERSION_MINOR} PARENT_SCOPE)
  set(SCIPOptSuite_VERSION_PATCH ${SCIP_VERSION_PATCH} PARENT_SCOPE)
  set(SCIP_DIR ${PROJECT_BINARY_DIR} PARENT_SCOPE)
endif()

set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_VERSION_MAJOR "${SCIP_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${SCIP_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${SCIP_VERSION_PATCH}")
set(CPACK_PACKAGE_VENDOR "Zuse Institute Berlin")
set(CPACK_PACKAGE_CONTACT "http://scipopt.org")
include(CPack)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

if(SCIPOptSuite_BINARY_DIR)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCIPOptSuite_BINARY_DIR}/bin)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${SCIPOptSuite_BINARY_DIR}/lib)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${SCIPOptSuite_BINARY_DIR}/lib)
  #set(SCIP_DIR ${SCIPOptSuite_BINARY_DIR} PARENT_SCOPE)
endif()

# path to e.g. findGMP module
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)

option(SHARED "Build shared libraries" ON)
set(BUILD_SHARED_LIBS ${SHARED})
message(STATUS "Build shared libraries: " ${SHARED})

# make 'Release' the default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

option(AUTOBUILD "find and use dependencies as available" OFF)
set(AUTOBUILD_MSG "If you have troubles configuring, you can consider setting AUTOBUILD=ON to try and find optional packages as available.")
option(ZLIB "should zlib be linked" ON)
option(READLINE "should readline be linked" ON)
option(GMP "should gmp be linked" ON)
option(STATIC_GMP "prefer static gmp library" OFF)
option(PAPILO "should papilo library be linked" ON)
option(ZIMPL "should zimpl be linked" ON)
option(AMPL "should ampl interface be compiled" ON)
option(IPOPT "should ipopt be linked" ON)
option(LAPACK "should lapack be linked" OFF)
option(WORHP "should worhp be linked" OFF)
option(CONOPT "should conopt be linked" OFF)
option(THREADSAFE "should scip be compiled thread safe" ON)
option(LPSCHECK "double check SoPlex results with CPLEX" OFF)
option(NOBLKBUFMEM "should block and buffer memory be disabled" OFF)
option(NOBLKMEM "should block memory be disabled" OFF)
option(NOBUFMEM "should buffer memory be disabled" OFF)
option(DEBUGSOL "should the debug solution mechanism be enabled" OFF)
option(SANITIZE "should sanitizers be enabled if available" OFF)
option(COVERAGE "enable coverage support" OFF)
SET(COVERAGE_CTEST_ARGS "" CACHE STRING "additional ctest arguments for coverage")
option(MT "use static runtime libraries for Visual Studio compiler" OFF)
option(CXXONLY "use a c++ compiler for all source files" OFF)
option(LTO "Enable Link Time Optimization, aka Interprocedural Optimization" OFF)

if(LTO)
    include(CheckIPOSupported)
    check_ipo_supported(RESULT LTO_AVAILABLE LANGUAGES C OUTPUT output)
    if(LTO_AVAILABLE)
        message(STATUS "LTO available")

        # with link-time optimization enabled, we get additional warnings at link time on
        # - some presumed malloc() calls with size 18446744073709551608 ((uint)-1)
        # - some presumed memmove() calls in boost::container::short_vector via papilo to a 0-length memory
        # we disable these warnings (need to pass them to the compiler when linking)
        if((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "CLANG"))
           add_link_options(-Wno-alloc-size-larger-than -Wno-stringop-overflow)
        endif()
    else(LTO_AVAILABLE)
        message(STATUS "LTO not available: ${output}")
    endif(LTO_AVAILABLE)
else()
    message(STATUS "LTO not enabled")
    set(LTO_AVAILABLE FALSE)
endif()

set(MPFR AUTO CACHE STRING "should MPFR be linked")
set_property(CACHE MPFR PROPERTY STRINGS AUTO ON OFF)
string(TOUPPER ${MPFR} MPFR)

set(EXACTSOLVE AUTO CACHE STRING "compile with support for exact rational solve (requires GMP, MPFR and Boost)")
set_property(CACHE EXACTSOLVE PROPERTY STRINGS AUTO ON OFF)
string(TOUPPER ${EXACTSOLVE} EXACTSOLVE_UPPER) # Also allow "auto"

set(CHECKSTAGE AUTO CACHE STRING "enable stage checks")
set_property(CACHE CHECKSTAGE PROPERTY STRINGS AUTO ON OFF)
string(TOUPPER ${CHECKSTAGE} CHECKSTAGE)

# Initialize SCIP_WITH_EXACTSOLVE.
if(EXACTSOLVE)
    set(SCIP_WITH_EXACTSOLVE ON) # We disable it later if dependencies are missing.
else()
    set(SCIP_WITH_EXACTSOLVE OFF)
endif()

# Initialize SCIP_WITH_MPFR.
if(MPFR)
    set(SCIP_WITH_MPFR ON) # We disable it later if exact solving mode is disabled.
else()
    set(SCIP_WITH_MPFR OFF)
    if(SCIP_WITH_EXACTSOLVE)
        message(WARNING "EXACTSOLVE is disabled because this requires MPFR.")
        set(SCIP_WITH_EXACTSOLVE OFF)
    endif()
endif()

# Initialize SCIP_WITH_GMP.
if(GMP)
    set(SCIP_WITH_GMP ON)
else()
    set(SCIP_WITH_GMP OFF)
    if(SCIP_WITH_EXACTSOLVE)
        message(WARNING "EXACTSOLVE is disabled because this requires GMP. ${AUTOBUILD_MSG}")
        set(SCIP_WITH_EXACTSOLVE OFF)
    endif()
endif()

set(TPI tny CACHE STRING "options for thread support library")  #create the variable
set_property(CACHE TPI PROPERTY STRINGS none tny omp)  #define list of values GUI will offer for the variable

set(EXPRINT cppad CACHE STRING "options for expression interpreter")  #create the variable
set_property(CACHE EXPRINT PROPERTY STRINGS none cppad )  #define list of values GUI will offer for the variable

set(LPS spx CACHE STRING "options for LP solver")  #create the variable
set_property(CACHE LPS PROPERTY STRINGS spx cpx grb xprs clp glop msk qso highs none)  #define list of values GUI will offer for the variable
set(LPSEXACT AUTO CACHE STRING "options for exact LP solver") # Create the variable
set_property(CACHE LPSEXACT PROPERTY STRINGS spx qsoex none AUTO) # Define list of values GUI will offer for the variable.
string(TOUPPER ${LPSEXACT} LPSEXACT_UPPER) # To also allow "auto".

set(SYM snauty CACHE STRING "options for symmetry computation")  #create the variable
set_property(CACHE SYM PROPERTY STRINGS bliss sbliss nauty snauty dejavu none )  #define list of values GUI will offer for the variable

if(NOT (CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo" OR CMAKE_BUILD_TYPE STREQUAL "MinSizeRel"))
    message(FATAL_ERROR "You have not selected a valid CMAKE_BUILD_TYPE. Please select 'Release' or 'Debug'.")
endif()

if (NOT (LPSEXACT_UPPER STREQUAL "AUTO") AND NOT (LPSEXACT_UPPER STREQUAL "NONE") AND NOT (LPSEXACT_UPPER STREQUAL "SPX") AND NOT (LPSEXACT_UPPER STREQUAL "QSOEX"))
    message(FATAL_ERROR "Invalid value \"${LPSEXACT}\" for LPSEXACT. Please select 'auto', 'none', 'spx' or 'qsoex'.")
endif()

if(AUTOBUILD)
    message(STATUS "You are using the automatic build option AUTOBUILD=ON to find and use dependencies automatically.")
else()
    message(STATUS "You are not using the automatic build option. ${AUTOBUILD_MSG}")
endif() # AUTOBUILD

# Use C++14 standard; may be increased further down.
set(CMAKE_CXX_STANDARD 14)

#search the selected symmetry computation program
message(STATUS "Finding symmetry computation program \"${SYM}\"")

if(SYM STREQUAL "bliss" OR SYM STREQUAL "sbliss")
    if(SYM STREQUAL "bliss")
        message(STATUS "Support SYM: bliss")
        set(sym symmetry/compute_symmetry_bliss.cpp)
    else()
        message(STATUS "Support SYM: sassy+bliss")
        set(sym symmetry/compute_symmetry_sassy_bliss.cpp symmetry/build_dejavu_graph.cpp)
        # sassy needs C++-14
        set(CMAKE_CXX_STANDARD 14)
    endif()

    find_package(Bliss CONFIG HINTS ${BLISS_DIR})
    if(Bliss_FOUND)
        set(SYM_LIBRARIES Bliss::libbliss)
        set(SYM_PIC_LIBRARIES Bliss::libbliss)
        message(STATUS "Found Bliss: ${Bliss_DIR}")
    else()
        message(FATAL_ERROR "Bliss not found, try installing https://github.com/scipopt/bliss and specifying BLISS_DIR.")
    endif()
elseif(SYM STREQUAL "nauty" OR SYM STREQUAL "snauty")
    if(NAUTY_DIR)
        include_directories(${NAUTY_DIR})
        set(SYM_LIBRARIES ${NAUTY_DIR}/nauty/nauty.a)
        set(SYM_PIC_LIBRARIES ${NAUTY_DIR}/nauty/nauty.a)
    else()
        include_directories(src/nauty)
        set(sym nauty/nauty.c nauty/nautil.c nauty/nausparse.c nauty/schreier.c nauty/naurng.c)
    endif()
    if(SYM STREQUAL "nauty")
        message(STATUS "Support SYM: nauty")
        set(sym ${sym} symmetry/compute_symmetry_nauty.c)
    elseif(SYM STREQUAL "snauty")
        message(STATUS "Support SYM: sassy+nauty")
        set(sym ${sym} symmetry/compute_symmetry_sassy_nauty.cpp symmetry/build_dejavu_graph.cpp)
        # sassy needs C++-14
        set(CMAKE_CXX_STANDARD 14)
    endif()
elseif(SYM STREQUAL "dejavu")
    include_directories(src/dejavu)
    message(STATUS "Support SYM: dejavu")
    set(sym ${sym} symmetry/compute_symmetry_dejavu.cpp symmetry/build_dejavu_graph.cpp)
    # dejavu needs C++-14
    set(CMAKE_CXX_STANDARD 14)
elseif(SYM STREQUAL "none")
    message(STATUS "Support SYM: OFF")
    set(sym symmetry/compute_symmetry_none.cpp)
else()
    message(FATAL_ERROR "option SYM has wrong value")
endif()
if(SYM STREQUAL "sbliss" OR SYM STREQUAL "snauty" OR SYM STREQUAL "dejavu")
  install(FILES ${PROJECT_SOURCE_DIR}/src/dejavu/LICENSE DESTINATION ${CMAKE_INSTALL_DATADIR}/licenses/scip/dejavu)
endif()
if(SYM STREQUAL "nauty" OR SYM STREQUAL "snauty")
  install(FILES ${PROJECT_SOURCE_DIR}/src/nauty/COPYRIGHT DESTINATION ${CMAKE_INSTALL_DATADIR}/licenses/scip/nauty)
endif()

# if changing these flags, also update GCCWARN/GXXWARN in make/make.project
set(ADD_C_AND_CXX_FLAGS -pedantic -Wall -W -Wpointer-arith -Wcast-align -Wwrite-strings -Wshadow  -Wredundant-decls -Wdisabled-optimization -Wno-long-long -Wno-unknown-pragmas -Wno-unused-parameter)
set(ADD_C_FLAGS -Wsign-compare -Wstrict-prototypes -Wmissing-declarations -Wmissing-prototypes -Wno-override-init -Wno-uninitialized -Wno-maybe-uninitialized)
set(ADD_CXX_FLAGS -Wnon-virtual-dtor -Wreorder -Woverloaded-virtual -Wsign-promo -Wsynth -Wcast-qual -Wno-strict-overflow -Wno-psabi)

# disable fused floating point contraction to enhance reproducibility across compilers and architectures
if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    add_compile_options(/fp:precise)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    add_compile_options(-fp-model=precise)
    # to prevent symbols from svml exported twice we use the -shared-intel flag, see https://git.zib.de/integer/scip/issues/2872
    # this happens with the cplex static lib
    if(LPS MATCHES "cpx")
        add_compile_options(-shared-intel) # for c and cxx

=== Makefile ===
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *#
#*                                                                           *#
#*                  This file is part of the program and library             *#
#*         SCIP --- Solving Constraint Integer Programs                      *#
#*                                                                           *#
#*  Copyright (c) 2002-2026 Zuse Institute Berlin (ZIB)                      *#
#*                                                                           *#
#*  Licensed under the Apache License, Version 2.0 (the "License");          *#
#*  you may not use this file except in compliance with the License.         *#
#*  You may obtain a copy of the License at                                  *#
#*                                                                           *#
#*      http://www.apache.org/licenses/LICENSE-2.0                           *#
#*                                                                           *#
#*  Unless required by applicable law or agreed to in writing, software      *#
#*  distributed under the License is distributed on an "AS IS" BASIS,        *#
#*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *#
#*  See the License for the specific language governing permissions and      *#
#*  limitations under the License.                                           *#
#*                                                                           *#
#*  You should have received a copy of the Apache-2.0 license                *#
#*  along with SCIP; see the file LICENSE. If not visit scipopt.org.         *#
#*                                                                           *#
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *#

#@file    Makefile
#@brief   SCIP Makefile
#@author  Thorsten Koch
#@author  Tobias Achterberg
#@author  Marc Pfetsch
#@author  Timo Berthold

#-----------------------------------------------------------------------------
# paths variables
#-----------------------------------------------------------------------------

SCIPDIR		=	./

INSTALLDIR	=

#-----------------------------------------------------------------------------
# include make.project file
#-----------------------------------------------------------------------------

# mark that this is a SCIP internal makefile
SCIPINTERNAL	=	true

# load default settings and detect host architecture
include $(SCIPDIR)/make/make.project

#-----------------------------------------------------------------------------
# default settings
#-----------------------------------------------------------------------------

VERSION		=	$(SCIP_VERSION)
SCIPGITHASH	=
SOFTLINKS	=
MAKESOFTLINKS	=	true

#-----------------------------------------------------------------------------
# define build flags
#-----------------------------------------------------------------------------
BUILDFLAGS =	" ARCH=$(ARCH)\\n\
		COMP=$(COMP)\\n\
		OSTYPE=$(OSTYPE)\\n\
		OPT=$(OPT)\\n\
		LTO=$(LTO)\\n\
		SANITIZE=$(SANITIZE)\\n\
		SHARED=$(SHARED)\\n\
		CHECKSTAGE=$(CHECKSTAGE)\\n\
		DEBUGSOL=$(DEBUGSOL)\\n\
		EXACTSOLVE=$(EXACTSOLVE)\\n\
		NOBLKBUFMEM=$(NOBLKBUFMEM)\\n\
		NOBLKMEM=$(NOBLKMEM)\\n\
		NOBUFMEM=$(NOBUFMEM)\\n\
		THREADSAFE=$(THREADSAFE)\\n\
		USRARFLAGS=$(USRARFLAGS)\\n\
		USRCFLAGS=$(USRCFLAGS)\\n\
		USRCXXFLAGS=$(USRCXXFLAGS)\\n\
		USRFLAGS=$(USRFLAGS)\\n\
		USRLDFLAGS=$(USRLDFLAGS)\\n\
		USROFLAGS=$(USROFLAGS)\\n\
		VERSION=$(VERSION)\\n\
		AMPL=$(AMPL)\\n\
		BOOST=$(BOOST)\\n\
		CONOPT=$(CONOPT)\\n\
		EXPRINT=$(EXPRINT)\\n\
		IPOPTOPT=$(IPOPTOPT)\\n\
		GMP=$(GMP)\\n\
		LAPACK=$(LAPACK)\\n\
		LPSCHECK=$(LPSCHECK)\\n\
		LPSOPT=$(LPSOPT)\\n\
		MPFR=$(MPFR)\\n\
		PAPILO=$(PAPILO)\\n\
		READLINE=$(READLINE)\\n\
		SYM=$(SYM)\\n\
		WORHP=$(WORHP)\\n\
		WORHPOPT=$(WORHPOPT)\\n\
		ZIMPL=$(ZIMPL)\\n\
		ZIMPLOPT=$(ZIMPLOPT)\\n\
		ZLIB=$(ZLIB)"

#-----------------------------------------------------------------------------
# LP Solver Interface
#-----------------------------------------------------------------------------

LPILIBOBJ	=
LPSOPTIONS	=
LPIINSTMSG	=

LPSOPTIONS	+=	cpx
ifeq ($(LPS),cpx)
FLAGS		+=	-I$(LIBDIR)/include/cpxinc
LPILIBOBJ	=	lpi/lpi_cpx.o scip/bitencode.o blockmemshell/memory.o scip/rbtree.o scip/message.o
LPILIBSRC  	=	$(addprefix $(SRCDIR)/,$(LPILIBOBJ:.o=.c))
SOFTLINKS	+=	$(LIBDIR)/include/cpxinc
ifeq ($(SHARED),true)
SOFTLINKS	+=	$(LIBDIR)/shared/libcplex.$(OSTYPE).$(ARCH).$(COMP).$(SHAREDLIBEXT)
else
SOFTLINKS	+=	$(LIBDIR)/static/libcplex.$(OSTYPE).$(ARCH).$(COMP).$(STATICLIBEXT)
endif
LPIINSTMSG	=	"  -> \"cpxinc\" is the path to the CPLEX \"include\" directory, e.g., \"<CPLEX-path>/include/ilcplex\".\n"
LPIINSTMSG	+=	" -> \"libcplex.*.a\" is the path to the CPLEX library, e.g., \"<CPLEX-path>/lib/x86-64_linux/static_pic/libcplex.a\"\n"
LPIINSTMSG	+=	" -> \"libcplex.*.so\" is the path to the CPLEX library, e.g., \"<CPLEX-path>/bin/x86-64_linux/libcplex1263.so\""
endif

# XPRESS is only available as shared library
LPSOPTIONS	+=	xprs
ifeq ($(LPS),xprs)
FLAGS		+=	-I$(LIBDIR)/include/xprsinc
LPILIBOBJ	=	lpi/lpi_xprs.o scip/bitencode.o blockmemshell/memory.o scip/rbtree.o scip/message.o
LPILIBSRC  	=	$(addprefix $(SRCDIR)/,$(LPILIBOBJ:.o=.c))
SOFTLINKS	+=	$(LIBDIR)/include/xprsinc
SOFTLINKS	+=	$(LIBDIR)/shared/libxprs.$(OSTYPE).$(ARCH).$(COMP).$(SHAREDLIBEXT)
LPIINSTMSG	=	"  -> \"xprsinc\" is the path to the XPRESS \"include\" directory, e.g., \"<XPRESS-path>/include\".\n"
LPIINSTMSG	+=	" -> \"libxprs.*\" is the path to the XPRESS library, e.g., \"<XPRESS-path>/lib/libxprs.so\""
endif

# mosek only supports shared libraries
LPSOPTIONS	+=	msk
ifeq ($(LPS),msk)
FLAGS		+=	-I$(LIBDIR)/include/mskinc
LPILIBOBJ	=	lpi/lpi_msk.o scip/bitencode.o blockmemshell/memory.o scip/rbtree.o scip/message.o
LPILIBSRC  	=	$(addprefix $(SRCDIR)/,$(LPILIBOBJ:.o=.c))
SOFTLINKS	+=	$(LIBDIR)/include/mskinc
SOFTLINKS	+=	$(LIBDIR)/shared/libmosek.$(OSTYPE).$(ARCH).$(COMP).$(SHAREDLIBEXT)
SOFTLINKS	+=	$(LIBDIR)/shared/libiomp5.$(OSTYPE).$(ARCH).$(COMP).$(SHAREDLIBEXT)    # for Mosek < 9
SOFTLINKS	+=	$(LIBDIR)/shared/libcilkrts.$(OSTYPE).$(ARCH).$(COMP).$(SHAREDLIBEXT)  # for Mosek < 10
LPIINSTMSG	=	"  -> \"mskinc\" is the path to the Mosek \"include\" directory, e.g., \"<Mosek-path>/tools/platform/linux64x86/h\".\n"
LPIINSTMSG	+=	" -> \"libmosek.*\" is the path to the Mosek library, e.g., \"<Mosek-path>/tools/platform/linux64x86/bin/libmosek64.so\".\n"
LPIINSTMSG	+=	" -> \"libiomp5.*\" is the path to the Intel OpenMP library, e.g., \"<Mosek-path>/tools/platform/linux64x86/bin/libiomp5.so\" (required for Mosek < 9.0 only).\n"
LPIINSTMSG	+=	" -> \"libcilkrts.*\" is the path to the cilk library, e.g., \"<Mosek-path>/tools/platform/linux64x86/bin/libcilkrts.so.5\" (required for Mosek < 10.0 only).\n"
endif

LPSOPTIONS	+=	spx
ifeq ($(LPS),spx)
LINKER		=	CPP
FLAGS		+=	-I$(LIBDIR)/include/spxinc
ifeq ($(MPFR),true)
LPSLDFLAGS	+=	$(MPFR_LDFLAGS)
endif
LPILIBOBJ	=	lpi/lpi_spx.o scip/bitencode.o blockmemshell/memory.o scip/rbtree.o scip/message.o
LPILIBSRC	=	$(SRCDIR)/lpi/lpi_spx.cpp $(SRCDIR)/scip/bitencode.c $(SRCDIR)/blockmemshell/memory.c $(SRCDIR)/scip/rbtree.c $(SRCDIR)/scip/message.c
SOFTLINKS	+=	$(LIBDIR)/include/spxinc
ifeq ($(SHARED),true)
SOFTLINKS	+=	$(LIBDIR)/shared/libsoplex.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT).$(SHAREDLIBEXT)
else
SOFTLINKS	+=	$(LIBDIR)/static/libsoplex.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT).$(STATICLIBEXT)
endif
LPIINSTMSG	=	"  -> \"spxinc\" is the path to the SoPlex \"src\" directory, e.g., \"<SoPlex-path>/src\".\n"
LPIINSTMSG	+=	" -> \"libsoplex.*\" is the path to the SoPlex library, e.g., \"<SoPlex-path>/lib/libsoplex.linux.x86.gnu.opt.a\""
ifeq ($(LPSCHECK),true)
FLAGS		+=	-I$(LIBDIR)/include/cpxinc
SOFTLINKS	+=	$(LIBDIR)/include/cpxinc
ifeq ($(SHARED),true)
SOFTLINKS	+=	$(LIBDIR)/shared/libcplex.$(OSTYPE).$(ARCH).$(COMP).$(SHAREDLIBEXT)
else
SOFTLINKS	+=	$(LIBDIR)/static/libcplex.$(OSTYPE).$(ARCH).$(COMP).$(STATICLIBEXT)
endif
LPIINSTMSG	+=	"  -> \"cpxinc\" is the path to the CPLEX \"include\" directory, e.g., \"<CPLEX-path>/include/ilcplex\".\n"
LPIINSTMSG	+=	" -> \"libcplex.*.a\" is the path to the CPLEX library, e.g., \"<CPLEX-path>/lib/x86_rhel4.0_3.4/static_pic/libcplex.a\"\n"
LPIINSTMSG	+=	" -> \"libcplex.*.so\" is the path to the CPLEX library, e.g., \"<CPLEX-path>/bin/x86-64_linux/libcplex1263.so\""
endif
endif

LPSOPTIONS	+=	clp
ifeq ($(LPS),clp)
LINKER		=	CPP
FLAGS		+=	-I$(LIBDIR)/$(LIBTYPE)/clp.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT)/include/coin -I$(LIBDIR)/$(LIBTYPE)/clp.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT)/include/coin-or
LPILIBOBJ	=	lpi/lpi_clp.o scip/bitencode.o blockmemshell/memory.o scip/rbtree.o scip/message.o
LPILIBSRC	=	$(SRCDIR)/lpi/lpi_clp.cpp $(SRCDIR)/scip/bitencode.c $(SRCDIR)/blockmemshell/memory.c $(SRCDIR)/scip/rbtree.c $(SRCDIR)/scip/message.c
SOFTLINKS	+=	$(LIBDIR)/$(LIBTYPE)/clp.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT)
LPIINSTMSG	=	"  -> \"clp.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT)\" is the path to the Clp installation directory, i.e., \"<Clp-path>/include/coin/ClpModel.hpp\" should exist.\n"
endif

LPSOPTIONS	+=	highs
ifeq ($(LPS),highs)
LINKER		=	CPP
FLAGS		+=	-I$(LIBDIR)/$(LIBTYPE)/highs.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT)/
LPILIBOBJ	=	lpi/lpi_highs.o scip/bitencode.o blockmemshell/memory.o scip/message.o
LPILIBSRC	=	$(SRCDIR)/lpi/lpi_highs.cpp $(SRCDIR)/scip/bitencode.c $(SRCDIR)/blockmemshell/memory.c $(SRCDIR)/scip/message.c
SOFTLINKS	+=	$(LIBDIR)/$(LIBTYPE)/highs.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT)
LPIINSTMSG	=	"  -> \"highs.$(OSTYPE).$(ARCH).$(COMP).$(LPSOPT)\" is the path to the HiGHS directory containing headers and libhighs.so.\n"
endif

LPSOPTIONS	+=	qso
ifeq ($(LPS),qso)
FLAGS         	+=      -I$(LIBDIR)/include/qsinc
LPILIBOBJ     	= 	lpi/lpi_qso.o scip/bitencode.o blockmemshell/memory.o scip/rbtree.o scip/message.o
LPILIBSRC     	=       $(addprefix $(SRCDIR)/,$(LPILIBOBJ:.o=.c))
SOFTLINKS     	+=      $(LIBDIR)/include/qsinc
SOFTLINKS     	+=      $(LIBDIR)/static/libqsopt.$(OSTYPE).$(ARCH).$(COMP).$(STATICLIBEXT)
LPIINSTMSG	=	"  -> \"qsinc\" is the path to the QSopt \"include\" directory, e.g., \"<QSopt-path>\".\n"
LPIINSTMSG	+=	" -> \"libqsopt.*\" is the path to the QSopt library, e.g., \"<QSopt-path>/libqsopt.a\""
endif

# Gurobi only supports shared libraries
LPSOPTIONS	+=	grb
ifeq ($(LPS),grb)
FLAGS		+=	-I$(LIBDIR)/include/grbinc
LPILIBOBJ	=	lpi/lpi_grb.o blockmemshell/memory.o scip/rbtree.o scip/message.o
LPILIBSRC  	=	$(addprefix $(SRCDIR)/,$(LPILIBOBJ:.o=.c))
SOFTLINKS	+=	$(LIBDIR)/include/grbinc
SOFTLINKS	+=	$(LIBDIR)/shared/libgurobi.$(OSTYPE).$(ARCH).$(COMP).$(SHAREDLIBEXT)
LPIINSTMSG	=	"  -> \"grbinc\" is the path to the Gurobi \"include\" directory, e.g., \"<Gurobi-path>/include\".\n"
LPIINSTMSG	+=	" -> \"libgurobi.*\" is the path to the Gurobi library, e.g., \"<Gurobi-path>/lib/libgurobi.so\""
endif

# glop only supports shared libraries
LPSOPTIONS	+=	glop
ifeq ($(LPS),glop)
LPILIBOBJ	=	lpi/lpi_glop.o scip/bitencode.o scip/rbtree.o scip/message.o
LPILIBSRC  	=	$(SRCDIR)/lpi/lpi_glop.cpp $(SRCDIR)/scip/bitencode.c $(SRCDIR)/scip/rbtree.c $(SRCDIR)/scip/message.c
SOFTLINKS	+=	$(LIBDIR)/shared/ortools
LPIINSTMSG	=	"  -> \"ortools\" is the path to the OR-Tools directory.\n"
endif

LPSOPTIONS	+=	none
ifeq ($(LPS),none)
LPILIBOBJ	=	lpi/lpi_none.o blockmemshell/memory.o scip/rbtree.o scip/message.o
LPILIBSRC  	=	$(addprefix $(SRCDIR)/,$(LPILIBOBJ:.o=.c))
endif

LPILIB		=	$(LPILIBNAME).$(BASE)
LPILIBFILE	=	$(LIBDIR)/$(LIBTYPE)/lib$(LPILIB).$(LIBEXT)
LPILIBOBJFILES	=	$(addprefix $(LIBOBJDIR)/,$(LPILIBOBJ))
LPILIBLINK	=	$(LIBDIR)/$(LIBTYPE)/lib$(LPILIBSHORTNAME).$(BASE).$(LIBEXT)
LPILIBSHORTLINK = 	$(LIBDIR)/$(LIBTYPE)/lib$(LPILIBSHORTNAME).$(LIBEXT)
ALLSRC		+=	$(LPILIBSRC)

ifeq ($(SHARED),true)
LPILIBEXTLIBS	=	$(LIBBUILD_L)$(LIBDIR)/$(LIBTYPE) $(LPSLDFLAGS)
ifneq ($(LINKRPATH),)
LPILIBEXTLIBS	+=	$(LINKRPATH)$(realpath $(LIBDIR)/$(LIBTYPE))
endif
endif

=== applications/CMakeLists.txt ===
add_custom_target(applications)

add_subdirectory(Coloring EXCLUDE_FROM_ALL)
add_subdirectory(CycleClustering EXCLUDE_FROM_ALL)
add_subdirectory(MinIISC EXCLUDE_FROM_ALL)
add_subdirectory(Ringpacking EXCLUDE_FROM_ALL)
add_subdirectory(PBSolver EXCLUDE_FROM_ALL)
add_subdirectory(Scheduler EXCLUDE_FROM_ALL)

enable_testing()

=== check/CMakeLists.txt ===
include(CTest)

#
# add a custom SCIP check target 'scip_check'
#
add_custom_target(scip_check
                COMMAND ${CMAKE_CTEST_COMMAND} -R "default" -E "applications" --output-on-failure
                DEPENDS scip
                )

#
# add a phony target check, if it has not been defined in a different SCIP Optimization Suite project, yet
# and add 'scip_check' as a dependency.
#
if (NOT TARGET check)
    add_custom_target(check)
endif()

add_dependencies(check scip_check)

# copy data files to binary directory, so that they can be accessed with relative paths
# in settings files
file(COPY coverage/data DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/coverage)
#
# define the instance sets
#
# semicolon '\;' is used to split an instance and its optimal objective value
# For infeasible instances, '+infinity' is used (or '-infinity' in case of maximization)
#

#
# CP instances
#
set(instances_CP
    "instances/CP/linking.cip\;2"
    "instances/CP/j301_2.cip\;47"
    "instances/CP/disj_conj_rail.cip\;1324.43557422969"
    "instances/CP/stein27_super.cip\;1"
    "instances/CP/Demo5.cip\;2"
    )

set(settings_default
    "default"
)

set(instances_linking
    "instances/CP/linking.cip\;2"
    "instances/CP/linking2.cip\;2"
    "instances/CP/sched_10_2_1.cip\;11"
    "instances/CP/sched_10_3_3.cip\;17"
)

set(settings_linking
   "linking"
)

#
# settings to run a whole test. In order to run a sub-suite, use -R
#
set(settings_MIP
    "default"
    "heuristics_off"
    "separating_fast"
    "presolving_fast"
    "heuristics_fast"
    "separating_aggressive"
    "presolving_aggressive"
    "heuristics_aggressive"
    "emphasis_numerics"

    #constraints
    "indicatorlogicorsepa"
    "indicatoralterlp"

    #presolving and branching
    "convertinttobin_mostinf"
    "setppclifting_leastinf"

    #branching and propagation
    "pscost_proporbitope"

    #separation and branching
    "oddcyclelift_randomhybrid"
    "oddcycle_distribution"
    "cutsel_dynamic"
    "treemodel_ratio"
    "treemodel_sampling"
    "treemodel_svts_filter"
    "treemodel_svts_nofilter"

    #separation and heuristics
    "oddcycleliftheur_feaspump20"

    #heuristics and branching
    "heurlprows"
    "lns_epsgreedy_vanilla"
    "lns_exp3"
#    "dynamic"
    "intobj"
#    "nologicor"
    "xorsepaparity"
    "solvingphases"
#    "cloud"
    "uct_breadth_dualval"
    "conflictdiving"
    "tolerance"
)

#
# settings for the componentshandler test
#
set(settings_compHandlerTest
    "components_during_solve"
    )

#
# settings to run a reduced MIP test
#
set(settings_fastMIP
    "all_aggressive"
    "alldisp"
    "allfull"
    "bakvisualization"
    "fullstrongbfs"
    "cgmip"
    "cgmipdirect"
    "cgmipstrong"
    "cgmipviol"
    "lookahead-abbrev-bincons"
    "lookahead-addclique-scaledcutoffscore"
    "presolving_off"
    "separating_off"
    "separating_misc"
    "vbcvisualization"
    "enable_treeprofile_regression_forest"
    "../../../scripts/trainEstimation/periodic_report"
  )
set(settings_MIPEX
    "exact-default"
    "exact-exactlp"
    "exact-projshift"
    )
set(settings_MINLP
    "default"
    "undercover1"
    "undercover2"
    "rensnlp"
    "nlpdiving2"
    "nlpdiving3"
    "nlpdiving1-relprop"
    "nlpdivingsolvesubmip"
    "nlpdiving4"
    "separating_aggressive"
    "emphasis_numerics"
)

set(settings_branch
    "branch_inference"
)

set(settings_Symmetry_A
    "orbitalfixing-timing0"
    "orbitalfixing-timing1"
    "orbitalfixing-timing2"
    "orbitopes-timing0"
    "orbitopes-timing2"
    "orbitopes-timing2-static"
    )

set(settings_Symmetry_B
    "packingorbitopes-timing0"
    "packingorbitopes-timing2"
    "symresacks-timing0"
    "symresacks-timing2"
    "sst_leader-first_tiebreak-maxconflicts"
    "sst_leader-first_tiebreak-orbitmin"
    "sst_leader-maxconflicts_tiebreak-orbitmin"
    )

set(settings_Symmetry_MINLP
    "checksym"
    )

set(settings_sparsify
    "sparsifyaggr"
  )

set(settings_Benders
    "usebenders"
    "usebenders-tr"
    "usebenders-cutstrengthen"
   )

set(settings_BendersLB
    "usebenders"
   )

set(settings_BendersQP
    "benders-qp"
   )

set(settings_BendersDec
    "usebenders-dec"
)

set(settings_Decomp
   "decompheurs"
   "decompheurs_dps"
  )

set(settings_Indicator
    "default"
    "indicatorrestart"
    "indicatorperspective"
    "indicatorlogicorsepa"
    "indicatorcoupling"
    "indicatorconflict"
    "indicatoralterlp"
    "indicatorupgrade"
    "indicatorobbt"
   )

set(settings_reopt
    "reopt-test-settings-usesplitcons-TRUE"
    "reopt-test-settings-varorderinterdiction-d"
    "reopt-test-settings-varorderinterdiction-i"
    "reopt-test-settings-varorderinterdiction-r"
    )

#
# Indicator instances
#
set(instances_Indicator
    "instances/Indicator/mcf128-4-1.lp\;14"
    "instances/Indicator/mcf64-4-1.lp\;10"
)

set(settings_Cardinality
    "default"
#    "upgdcardinality"
)

set(settings_Or
    "default"
    "presolving_separating_heuristics_off_randombranching"
    "repropagation"
    "tolerance"
)

#
# consecutive solve instances
#
set(instances_consecSolve
  "instances/MIP/blend2.mps\;7.598985"
  "instances/MIP/bell5.mps\;8966406.49"
  "instances/MIP/stein27.fzn\;18"
  "instances/MINLP/bip_cross_min.10.10.10.1.pip\;1"
  "instances/MINLP/circle.lp\;4.57424778"
  "instances/MINLP/ex1266.mps\;16.3"
  "instances/MINLP/m3.osil\;37.8"
  "instances/PseudoBoolean/normalized-bsg_10_4_5.opb\;-4"
  "instances/MINLP/meanvarxsc.lp\;14.3692321148754"
  "instances/SOS/sparse2.lp\;26.0"
  "instances/Cardinality/atm_5_25_1.cip\;+1.40606905557936e+05"
  "instances/Stochastic/4node1.smps\;480.9"
  "instances/SAT/bart10.shuffled.cnf\;0"
  )

#
# read/write instances
#
set(instances_MIP_write
#    "instances/MIP/bell5.mps\;8966406.49"
#    "instances/MIP/egout.mps\;568.1007"
#    "instances/MIP/flugpl.mps\;1201500"
#    "instances/MIP/MANN_a9.clq.lp\;16"
    "instances/MIP/p0033.osil\;3089"
    "instances/MIP/stein27.fzn\;18"
    "instances/MIP/stein27_inf.lp\;+infinity"
    )

#
# MIP instances
#
set(instances_MIP
    "instances/MIP/bell5.mps\;8966406.49"
    "instances/MIP/blend2.mps\;7.598985"
#    "instances/MIP/dcmulti.mps\;188182"
    "instances/MIP/egout.mps\;568.1007"
    "instances/MIP/enigma.mps\;0"
    "instances/MIP/flugpl.mps\;1201500"
    "instances/MIP/gt2.mps\;21166"
    "instances/MIP/lseu.mps\;1120"
    "instances/MIP/MANN_a9.clq.lp\;16"
    "instances/MIP/misc03.mps\;3360"
    "instances/MIP/Negated.cip\;1"
    "instances/MIP/p0033.osil\;3089"
    "instances/MIP/p0548.mps\;8691"
    "instances/MIP/piperout-impl.cip\;0"
    "instances/MIP/rgn.mps\;82.19999924"
    "instances/MIP/stein27.fzn\;18"
    "instances/MIP/stein27_inf.lp\;+infinity"
    "instances/MIP/vpm2.fzn\;13.75"
    )

#
# Instances for component handler test
#
set(instances_compHandlerTest
    "instances/MIP/lseu_dcmulti.cip\;189302"
    "instances/MIP/4sHB.cip\;67"
    )

#
# Reduced set of MIP instances for more expensive settings
#
set(instances_fastMIP
    "instances/MIP/bell5.mps\;8966406.49"
    "instances/MIP/egout.mps\;568.1007"
    "instances/MIP/gt2.mps\;21166"
    "instances/MIP/MANN_a9.clq.lp\;16"
    "instances/MIP/p0033.osil\;3089"
    "instances/MIP/Side.lp\;2"
    )

#
# add additional ZIMPL instances if the configuration uses ZIMPL
#
if(SCIP_WITH_ZIMPL)
    list(APPEND
        instances_Indicator
        "instances/Indicator/indicatortest.zpl\;-2"
        "instances/Indicator/mcf64-4-1.zpl\;10"
    )
#
# this instance was part of the original coverage tests. However, it causes
# a significant overhead without providing relevant benefit.
#
#list(APPEND
#    instances_MIP
#    "instances/MIP/rocII_2_11.zpl\;+4.61527698552400e+00"
#    )
endif()

# exact ip instances
if(SCIP_WITH_EXACTSOLVE)
    set(instances_MIPEX
        "instances/MIPEX/egout.cip\;5681007/10000"
        "instances/MIP/enigma.mps\;0"
        "instances/MIPEX/flugpl_rational.mps\;1201500"
        "instances/MIP/Side.lp\;2"
        "instances/MIPEX/Side-coef.cip\;2"
        "instances/MIPEX/Side-coeftest.lp\;2"
        "instances/MIP/stein27_inf.lp\;+infinity"
        "instances/PseudoBoolean/normalized-t2001.13queen13.1111218308.opb\;+infinity"
    )
    if(SCIP_WITH_ZIMPL)
        list(APPEND
            instances_MIPEX
            # instance misc03p1 appended later
            "instances/MIPEX/rgn.zpl\;2054999981/25000000"
            "instances/MIPEX/stein27.zpl\;18"
        )
    endif()
endif()

#
# MINLP instances
#
set(instances_MINLP
    "instances/MINLP/bip_cross_min.10.10.10.1.pip\;1"
    "instances/MINLP/circle.lp\;4.57424778"
    "instances/MINLP/ex1266.mps\;16.3"
    "instances/MINLP/m3.osil\;37.8"
    "instances/MINLP/parincQuadratic.osil\;49920.5564"
    "instances/MINLP/tltr.mps\;48.0666666667"
    )

set(instances_branch
    "instances/MIP/egout.mps\;568.1007"
    "instances/MIP/MANN_a9.clq.lp\;16"
    "instances/MIP/p0033.osil\;3089"
    "instances/MINLP/circle.lp\;4.57424778"
    "instances/MINLP/ex1266.mps\;16.3"
    )

set(instances_Bilinrelax
    "instances/MINLP/pointpack04.osil\;1.00000024988836"
    "instances/MINLP/pointpack06.osil\;0.361111675167215"
  )

#
# PB instances
#
set(instances_PB
    "instances/PseudoBoolean/factor-mod-size=9-P0=263-P1=409-P2=29-P3=379-B.opb\;3"
    "instances/PseudoBoolean/normalized-bsg_10_4_5.opb\;-4"
    "instances/PseudoBoolean/normalized-mds_10_4_3.opb\;2"
    "instances/PseudoBoolean/normalized-mds_50_25_5.opb\;3"
    "instances/PseudoBoolean/normalized-90_rounds_0_errors.opb\;0"
    "instances/PseudoBoolean/normalized-t2001.13queen13.1111218308.opb\;+infinity"
    "instances/PseudoBoolean/normalized-t2001.13queen13.1110976730--soft-33-100-0.wbo\;4"
    "instances/PseudoBoolean/wheel010.lap.opb.pre.cip\;16"
    )

#
# sparsify instances
#
set(instances_sparsify
    "instances/MIP/blend2.mps\;7.598985"
    "instances/PseudoBoolean/normalized-t2001.13queen13.1111218308.opb\;+infinity"
    )

#
# Semicontinuous instances
#
set(instances_Semicontinuous
    "instances/MINLP/meanvarxsc.lp\;14.3692321148754"
    "instances/MIP/semicon1.mps\;1.1"
    )

#
# SAT instance(s)
#
set(instances_SAT
    "instances/SAT/bart10.shuffled.cnf\;0"
    )

#
# Cardinality instances. Testing with or without cardinality upgrade
# should yield the same optimal solution
#
set(instances_Cardinality
#    "instances/Cardinality/atm_5_10_1.lp\;+5.97040200941306e+04"
    "instances/Cardinality/atm_5_25_1.cip\;+1.40606905557936e+05"
    "instances/Cardinality/atm_5_25_3.cip\;+1.35160667451104e+05"
    )

#
# SOS instances
#
set(instances_SOS
    "instances/SOS/findRoot.lp\;1.0"
    "instances/SOS/pcu_0.01.lp\;0.167527525"
    "instances/SOS/pcu_0.1.lp\;0.185145653"
    "instances/SOS/sparse2.lp\;26.0"
    "instances/SOS/tpesc.lp\;54027.1672208127"
    )

#
# Orbitope/Orbisack/Symresack instances
#
set(instances_SymmetryConss
    "instances/Symmetry/packorb_1-FullIns_3.cip\;28"
    "instances/Symmetry/partorb_1-FullIns_3.cip\;4"
    "instances/Symmetry/packorbisack_1-FullIns_3.cip\;4"
    "instances/Symmetry/symresack_1-FullIns_3.cip\;28"
    )

#
# Symmetry instances
#
set(instances_Symmetry_A
    "instances/MIP/MANN_a9.clq.lp\;16"
    "instances/MIP/rgn.mps\;82.19999924"
    "instances/MIP/stein27.fzn\;18"
    )

set(instances_Symmetry_B
    "instances/MIP/stein27_inf.lp\;+infinity"
    "instances/PseudoBoolean/wheel010.lap.opb.pre.cip\;16"
    )

#
# Symmetry MINLP instances
#
set(instances_Symmetry_MINLP
    "instances/MINLP/gastrans.osil\;89.0858400000"
    "instances/MINLP/tln2.osil\;5.3000000000"
    "instances/MINLP/cvxnonsep_psig40r.osil\;86.5450782341784"
    )

#
# Stochastic programming instances
#
set(instances_Stochastic
   "instances/Stochastic/pltexpA2_6.smps\;-9.479354404641"
   "instances/Stochastic/pltexpA2_16.smps\;-9.663308373027"
   "instances/Stochastic/pltexpA4_6.smps\;-19.5994173819041"
   "instances/Stochastic/sslp_5_25_5.smps\;-100.6"
   )

set(instances_Benders
    "instances/Stochastic/4node1.smps\;480.9"

=== doc/CMakeLists.txt ===
#
# @author Gregor Hendel
#
# this directory adds a doc target
#
#
#

#
# a couple of programs are required on the path
#
find_program(PYTHON python3)
find_program(BASH bash)
find_program(DOXYGEN doxygen)


if(NOT (PYTHON AND BASH AND DOXYGEN))
    message(WARNING "Could not find all of doxygen, python3, and bash in system path, which are required for generation of documentation")
else()

    # change this variable to 'php' the web page

    set(DOC_HTML_FILE_EXTENSION html)

    # Shell Tutorial Is Built In 2 Steps
    #
    # 1a. create the raw shell tutorial using commands for SCIP
    #
    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/inc/shelltutorial/shelltutorialraw.tmp
        COMMAND $<TARGET_FILE:scip> < doc/inc/shelltutorial/commands | tee doc/inc/shelltutorial/shelltutorialraw.tmp
        COMMAND ${BASH} -c "rm stein27.lp stein27.sol settingsfile.set"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
    )

    #
    # 1b. create the shelltutorial that contains annotations for doxygen
    #
    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/inc/shelltutorial/shelltutorialannotated.tmp
        COMMAND ${PYTHON} inc/shelltutorial/insertsnippetstutorial.py
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/inc/shelltutorial/shelltutorialraw.tmp
    )

    #
    # 2. create the FAQ
    #
    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/inc/faq.inc
        COMMAND ${PYTHON} parser.py --linkext ${DOC_HTML_FILE_EXTENSION}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/inc/faq
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR/inc/faq/faqtext.txt}
        )

    #
    # 3. parameter file generation
    #
    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/inc/parameters.set
        COMMAND $<TARGET_FILE:scip> -c "set default set save inc/parameters.set quit"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )

    #
    # 4. front page tutorial tutorial
    #
    # bin/scip -c "read doc/inc/simpleinstance/simple.lp optimize quit" > doc/inc/simpleinstance/output.log
    add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/inc/simpleinstance/output.log
        COMMAND $<TARGET_FILE:scip> -c "read inc/simpleinstance/simple.lp optimize quit" -l inc/simpleinstance/output.log
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )


    add_custom_target(doc
        ${DOXYGEN} scip.dxy
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/inc/shelltutorial/shelltutorialannotated.tmp
                ${CMAKE_CURRENT_SOURCE_DIR}/inc/faq.inc
                ${CMAKE_CURRENT_SOURCE_DIR}/inc/parameters.set
                ${CMAKE_CURRENT_SOURCE_DIR}/inc/simpleinstance/output.log
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        COMMENT "Generating doxygen documentation in ${CMAKE_CURRENT_SOURCE_DIR}/html/ ..."
                )
endif()

=== examples/CMakeLists.txt ===
add_custom_target(examples)

add_subdirectory(Binpacking EXCLUDE_FROM_ALL)
add_subdirectory(CallableLibrary EXCLUDE_FROM_ALL)
add_subdirectory(SCFLP EXCLUDE_FROM_ALL)
add_subdirectory(Eventhdlr EXCLUDE_FROM_ALL)
add_subdirectory(GMI EXCLUDE_FROM_ALL)
add_subdirectory(LOP EXCLUDE_FROM_ALL)
add_subdirectory(MIPSolver EXCLUDE_FROM_ALL)
add_subdirectory(Queens EXCLUDE_FROM_ALL)
add_subdirectory(Relaxator EXCLUDE_FROM_ALL)
add_subdirectory(TSP EXCLUDE_FROM_ALL)
add_subdirectory(VRP EXCLUDE_FROM_ALL)
add_subdirectory(Sudoku EXCLUDE_FROM_ALL)

enable_testing()

=== src/CMakeLists.txt ===
#
# interface function for setting common library properties
#
include(GNUInstallDirs)

function(setLibProperties targetname outputname)
    set_target_properties(${targetname} PROPERTIES
        OUTPUT_NAME ${outputname})
endfunction(setLibProperties)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED on)
set(CMAKE_C_EXTENSIONS OFF)

if(NOT WIN32)
    set(SCIP_COMP_OPTIONS ${SCIP_COMP_OPTIONS} "$<$<COMPILE_LANGUAGE:C>:-D_XOPEN_SOURCE=600>")
endif()

#configure the scipbuildflags.c source file for the build tree
configure_file(${PROJECT_SOURCE_DIR}/src/scipbuildflags.c.in
  "${PROJECT_BINARY_DIR}/scipbuildflag.c" @ONLY)

set(scipsources
    ${PROJECT_BINARY_DIR}/scipbuildflag.c
    blockmemshell/memory.c
    scip/message.c
    scip/bitencode.c
    scip/bandit.c
    scip/bandit_epsgreedy.c
    scip/bandit_exp3.c
    scip/bandit_exp3ix.c
    scip/bandit_ucb.c
    scip/branch_allfullstrong.c
    scip/branch_cloud.c
    scip/branch_distribution.c
    scip/branch_fullstrong.c
    scip/branch_gomory.c
    scip/branch_inference.c
    scip/branch_leastinf.c
    scip/branch_lookahead.c
    scip/branch_mostinf.c
    scip/branch_multaggr.c
    scip/branch_nodereopt.c
    scip/branch_pscost.c
    scip/branch_random.c
    scip/branch_relpscost.c
    scip/branch_vanillafullstrong.c
    scip/certificate.cpp
    scip/compr_largestrepr.c
    scip/compr_weakcompr.c
    scip/concsolver_scip.c
    scip/cons_and.c
    scip/cons_benders.c
    scip/cons_benderslp.c
    scip/cons_bounddisjunction.c
    scip/cons_cardinality.c
    scip/cons_components.c
    scip/cons_conjunction.c
    scip/cons_countsols.c
    scip/cons_cumulative.c
    scip/cons_disjunction.c
    scip/cons_exactlinear.c
    scip/cons_exactsol.c
    scip/cons_fixedvar.c
    scip/cons_indicator.c
    scip/cons_integral.c
    scip/cons_knapsack.c
    scip/cons_linear.c
    scip/cons_linking.c
    scip/cons_logicor.c
    scip/cons_nonlinear.c
    scip/cons_or.c
    scip/cons_orbisack.c
    scip/cons_orbitope.c
    scip/cons_orbitope_full.c
    scip/cons_orbitope_pp.c
    scip/cons_pseudoboolean.c
    scip/cons_setppc.c
    scip/cons_sos1.c
    scip/cons_sos2.c
    scip/cons_superindicator.c
    scip/cons_symresack.c
    scip/cons_varbound.c
    scip/cons_xor.c
    scip/cutsel_ensemble.c
    scip/cutsel_hybrid.c
    scip/cutsel_dynamic.c
    scip/dcmp.c
    scip/dialog_default.c
    scip/event_globalbnd.c
    scip/event_estim.c
    scip/event_shadowtree.c
    scip/event_softtimelimit.c
    scip/event_solvingphase.c
    scip/expr_abs.c
    scip/expr_entropy.c
    scip/expr_erf.c
    scip/expr_exp.c
    scip/expr_log.c
    scip/expr_pow.c
    scip/expr_product.c
    scip/expr_sum.c
    scip/expr_trig.c
    scip/expr_value.c
    scip/expr_var.c
    scip/expr_varidx.c
    ${exprinterpret}
    scip/disp_default.c
    scip/heur_actconsdiving.c
    scip/heur_adaptivediving.c
    scip/heur_bound.c
    scip/heur_clique.c
    scip/heur_coefdiving.c
    scip/heur_completesol.c
    scip/heur_conflictdiving.c
    scip/heur_crossover.c
    scip/heur_dins.c
    scip/heur_distributiondiving.c
    scip/heur_dks.c
    scip/heur_dps.c
    scip/heur_dualval.c
    scip/heur_farkasdiving.c
    scip/heur_feaspump.c
    scip/heur_fixandinfer.c
    scip/heur_fracdiving.c
    scip/heur_gins.c
    scip/heur_guideddiving.c
    scip/heur_indicator.c
    scip/heur_indicatordiving.c
    scip/heur_intdiving.c
    scip/heur_intshifting.c
    scip/heur_linesearchdiving.c
    scip/heur_localbranching.c
    scip/heur_lpface.c
    scip/heur_locks.c
    scip/heur_alns.c
    scip/heur_mutation.c
    scip/heur_multistart.c
    scip/heur_mpec.c
    scip/heur_nlpdiving.c
    scip/heur_objpscostdiving.c
    scip/heur_octane.c
    scip/heur_ofins.c
    scip/heur_oneopt.c
    scip/heur_padm.c
    scip/heur_proximity.c
    scip/heur_pscostdiving.c
    scip/heur_reoptsols.c
    scip/heur_repair.c
    scip/heur_randrounding.c
    scip/heur_rens.c
    scip/heur_rins.c
    scip/heur_rootsoldiving.c
    scip/heur_rounding.c
    scip/heur_scheduler.c
    scip/heur_shiftandpropagate.c
    scip/heur_shifting.c
    scip/heur_simplerounding.c
    scip/heur_subnlp.c
    scip/heur_sync.c
    scip/heur_trivial.c
    scip/heur_trivialnegation.c
    scip/heur_trustregion.c
    scip/heur_trysol.c
    scip/heur_twoopt.c
    scip/heur_undercover.c
    scip/heur_vbounds.c
    scip/heur_veclendiving.c
    scip/heur_zeroobj.c
    scip/heur_zirounding.c
    scip/hypergraph.c
    scip/iisfinder_greedy.c
    scip/message_default.c
    scip/network.c
    scip/nlhdlr_bilinear.c
    scip/nlhdlr_convex.c
    scip/nlhdlr_default.c
    scip/nlhdlr_perspective.c
    scip/nlhdlr_quadratic.c
    scip/nlhdlr_quotient.c
    scip/nlhdlr_signomial.c
    scip/nlhdlr_soc.c
    scip/nlpi_all.c
    ${nlpi}
    scip/nodesel_bfs.c
    scip/nodesel_breadthfirst.c
    scip/nodesel_dfs.c
    scip/nodesel_estimate.c
    scip/nodesel_hybridestim.c
    scip/nodesel_restartdfs.c
    scip/nodesel_uct.c
    scip/presol_milp.cpp
    scip/presol_boundshift.c
    scip/presol_convertinttobin.c
    scip/presol_domcol.c
    scip/presol_dualagg.c
    scip/presol_dualcomp.c
    scip/presol_dualinfer.c
    scip/presol_gateextraction.c
    scip/presol_implics.c
    scip/presol_implint.c
    scip/presol_inttobinary.c
    scip/presol_qpkktref.c
    scip/presol_redvub.c
    scip/presol_sparsify.c
    scip/presol_dualsparsify.c
    scip/presol_stuffing.c
    scip/presol_trivial.c
    scip/presol_tworowbnd.c
    scip/prop_dualfix.c
    scip/prop_genvbounds.c
    scip/prop_nlobbt.c
    scip/prop_obbt.c
    scip/prop_probing.c
    scip/prop_pseudoobj.c
    scip/prop_redcost.c
    scip/prop_rootredcost.c
    scip/prop_symmetry.c
    scip/prop_vbounds.c
    scip/prop_symmetry.c
    scip/prop_sync.c
    scip/reader_bnd.c
    scip/reader_ccg.c
    scip/reader_cip.c
    scip/reader_cnf.c
    scip/reader_cor.c
    scip/reader_dec.c
    scip/reader_diff.c
    scip/reader_fix.c
    scip/reader_fzn.c
    scip/reader_gms.c
    scip/reader_lp.c
    scip/reader_mps.c
    scip/reader_mst.c
    scip/reader_opb.c
    scip/reader_osil.c
    scip/reader_pip.c
    scip/reader_pbm.c
    scip/reader_ppm.c
    scip/reader_rlp.c
    scip/reader_sol.c
    scip/reader_sto.c
    scip/reader_smps.c
    scip/reader_tim.c
    scip/reader_wbo.c
    scip/reader_zpl.c
    scip/sepa_cgmip.c
    scip/sepa_clique.c
    scip/sepa_closecuts.c
    scip/sepa_aggregation.c
    scip/sepa_convexproj.c
    scip/sepa_disjunctive.c
    scip/sepa_eccuts.c
    scip/sepa_flower.c
    scip/sepa_gauge.c
    scip/sepa_gomory.c
    scip/sepa_impliedbounds.c
    scip/sepa_interminor.c
    scip/sepa_intobj.c
    scip/sepa_lagromory.c
    scip/sepa_mcf.c
    scip/sepa_minor.c
    scip/sepa_mixing.c
    scip/sepa_oddcycle.c
    scip/sepa_rapidlearning.c
    scip/sepa_rlt.c
    scip/sepa_zerohalf.c
    scip/treemodel.c
    scip/benders_default.c
    scip/benderscut_feas.c
    scip/benderscut_feasalt.c
    scip/benderscut_int.c
    scip/benderscut_nogood.c
    scip/benderscut_opt.c
    scip/table_default.c
    scip/benders.c
    scip/benderscut.c
    scip/bendersdefcuts.c
    scip/relax_benders.c
    scip/boundstore.c
    scip/branch.c
    scip/clock.c
    scip/concsolver.c
    scip/concurrent.c
    scip/conflict_general.c
    scip/conflict_graphanalysis.c
    scip/conflict_dualproofanalysis.c
    scip/conflict_resolution.c
    scip/conflictstore.c
    scip/cons.c
    scip/cutpool.c
    scip/cuts.c
    scip/cutsel.c
    scip/debug.c
    scip/dialog.c
    scip/disp.c
    scip/event.c
    scip/expr.c
    scip/exprcurv.c
    scip/expriter.c
    scip/fileio.c
    scip/heur.c
    scip/heuristics.c
    scip/compr.c
    scip/history.c
    scip/iisfinder.c
    scip/implics.c
    scip/interrupt.c
    scip/intervalarith.c
    scip/lapack_calls.c
    scip/lp.c
    scip/lpexact.c
    scip/lpexact_bounding.c
    scip/matrix.c
    scip/mem.c
    scip/misc.c
    scip/misc_linear.c
    scip/misc_rowprep.c
    scip/nlhdlr.c
    scip/nlp.c
    scip/nlpi.c
    scip/nlpioracle.c
    scip/nodesel.c
    scip/paramset.c
    scip/presol.c
    scip/presolve.c
    scip/pricestore.c
    scip/pricer.c
    scip/primal.c
    scip/prob.c
    scip/prop.c
    scip/rational.cpp
    scip/reader.c
    scip/relax.c
    scip/reopt.c
    scip/retcode.c
    scip/scip_bandit.c
    scip/scip_benders.c
    scip/scip_branch.c
    scip/scip_certificate.c
    scip/scip_compr.c
    scip/scip_concurrent.c
    scip/scip_conflict.c
    scip/scip_cons.c
    scip/scip_copy.c
    scip/scip_cut.c
    scip/scip_cutsel.c
    scip/scip_datastructures.c
    scip/scip_datatree.c
    scip/scip_debug.c
    scip/scip_dcmp.c
    scip/scip_dialog.c
    scip/scip_disp.c
    scip/scip_event.c
    scip/scip_exact.c
    scip/scip_expr.c
    scip/scip_general.c
    scip/scip_heur.c
    scip/scip_iisfinder.c
    scip/scip_lp.c
    scip/scip_lpexact.c
    scip/scip_mem.c
    scip/scip_message.c
    scip/scip_nlp.c
    scip/scip_nlpi.c
    scip/scip_nodesel.c
    scip/scip_numerics.c
    scip/scip_param.c
    scip/scip_presol.c
    scip/scip_pricer.c
    scip/scip_prob.c
    scip/scip_probing.c
    scip/scip_prop.c
    scip/scip_randnumgen.c
    scip/scip_reader.c
    scip/scip_relax.c
    scip/scip_reopt.c
    scip/scip_sepa.c
    scip/scip_sol.c
    scip/scip_solve.c
    scip/scip_solvingstats.c
    scip/scip_table.c
    scip/scip_timing.c
    scip/scip_tree.c
    scip/scip_validation.c
    scip/scip_var.c
    scip/datatree.c
    scip/scipdefplugins.c
    scip/scipcoreplugins.c
    scip/scipgithash.c
    scip/scipshell.c
    scip/sepa.c
    scip/sepastore.c
    scip/sepastoreexact.c
    scip/set.c
    scip/sol.c
    scip/solve.c
    scip/stat.c
    scip/symmetry.c
    scip/symmetry_graph.c
    scip/symmetry_orbitopal.c
    scip/symmetry_orbital.c
    scip/symmetry_lexred.c
    scip/syncstore.c
    scip/table.c
    scip/tree.c
    scip/var.c
    scip/visual.c
    scip/rbtree.c
    tclique/tclique_branch.c
    tclique/tclique_coloring.c
    tclique/tclique_graph.c
    dijkstra/dijkstra.c
    xml/xmlparse.c
    ${amplsrc}
)

set(objscipsources
    objscip/objbenders.cpp
    objscip/objbenderscut.cpp
    objscip/objbranchrule.cpp
    objscip/objconshdlr.cpp
    objscip/objcutsel.cpp
    objscip/objdialog.cpp
    objscip/objdisp.cpp
    objscip/objeventhdlr.cpp
    objscip/objexprhdlr.cpp
    objscip/objheur.cpp
    objscip/objiisfinder.cpp
    objscip/objmessagehdlr.cpp
    objscip/objnodesel.cpp
    objscip/objpresol.cpp
    objscip/objpricer.cpp
    objscip/objprobdata.cpp
    objscip/objprop.cpp
    objscip/objreader.cpp
    objscip/objrelax.cpp
    objscip/objsepa.cpp
    objscip/objtable.cpp
    objscip/objvardata.cpp
)

set(lpisources
   ${lpi}
   )

set(symsources
   ${sym}
   )

set(lpiexactsources
   ${lpiexact}
   )

if(SCIP_WITH_EXACTSOLVE)
set(rectlusources
   rectlu/rectlu_factor.c
   rectlu/rectlu_num.c
   )

set(rectluheaders
    rectlu/rectlu.h
    rectlu/rectlu_num.h
    rectlu/rectlu_factor.h)
endif()

set(blockmemshellheader
    blockmemshell/memory.h
)

set(lpiheaders
    lpi/lpi.h
    lpi/type_lpi.h
)

set(lpiexactheaders
    lpiexact/lpiexact.h
    lpiexact/type_lpiexact.h
)

set(dijkstraheaders
    dijkstra/dijkstra.h
)

set(objscipheaders
    objscip/objbenders.h
    objscip/objbenderscut.h
    objscip/objbranchrule.h
    objscip/objcloneable.h
    objscip/objconshdlr.h
    objscip/objcutsel.h
    objscip/objdialog.h
    objscip/objdisp.h
    objscip/objeventhdlr.h
    objscip/objexprhdlr.h
    objscip/objheur.h
    objscip/objiisfinder.h
    objscip/objmessagehdlr.h
    objscip/objnodesel.h
    objscip/objpresol.h
    objscip/objpricer.h
    objscip/objprobcloneable.h
    objscip/objprobdata.h
    objscip/objprop.h
    objscip/objreader.h
    objscip/objrelax.h
    objscip/objscipdefplugins.h
    objscip/objscip.h
    objscip/objsepa.h
    objscip/objtable.h
    objscip/objvardata.h
    objscip/type_objcloneable.h
    objscip/type_objprobcloneable.h
)

set(scipheaders
    scip/bandit.h
    scip/bandit_epsgreedy.h
    scip/bandit_exp3.h

=== tests/CMakeLists.txt ===
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*                  This file is part of the program and library             *
#*         SCIP --- Solving Constraint Integer Programs                      *
#*                                                                           *
#*  Copyright (c) 2002-2026 Zuse Institute Berlin (ZIB)                      *
#*                                                                           *
#*  Licensed under the Apache License, Version 2.0 (the "License");          *
#*  you may not use this file except in compliance with the License.         *
#*  You may obtain a copy of the License at                                  *
#*                                                                           *
#*      http://www.apache.org/licenses/LICENSE-2.0                           *
#*                                                                           *
#*  Unless required by applicable law or agreed to in writing, software      *
#*  distributed under the License is distributed on an "AS IS" BASIS,        *
#*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
#*  See the License for the specific language governing permissions and      *
#*  limitations under the License.                                           *
#*                                                                           *
#*  You should have received a copy of the Apache-2.0 license                *
#*  along with SCIP; see the file LICENSE. If not visit scipopt.org.         *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

#@file    tests/CMakeLists.txt
#@brief   CMake lists file for including unit tests
#@author  Gregor Hendel

include(CTest)

#
# this directory contains unit tests for certain units of SCIP
#
# the build file generation recursively scans all src-directories for
# C-files and creates an executable that respects the given directory
# structure (relative to ./src/) in the build directory under tests/.
# The executable is dynamically linked to (and automatically depends on)
# the generated SCIP library.
#
# Finally, a test is added for every executable.
#

#
# define the C99 standard for older compilers (gcc < 5.0)
#
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED on)

#
# unit tests depend on the presence of the Criterion framework
#
if( CRITERION_FOUND )

    #
    # glob recurse into the src/ subdirectory and collect all C-files
    #
    file(GLOB_RECURSE TEST_SRCS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/src
        ${CMAKE_CURRENT_SOURCE_DIR}/src/*.c)

    #
    # besides Criterion, we also include the current source directory for test specific implementations,
    # and the source directory of the parent SCIP directory to be able to include C-sources of SCIP
    # into our unittests
    #
    include_directories(BEFORE PUBLIC ${CRITERION_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../src)

    if(SANITIZE)
        find_package(Sanitizers)
    endif(SANITIZE)

    #
    # Prepare unit test executable for every source file
    #
    foreach(testSrc ${TEST_SRCS})
        #
        # extract the filename without an extension and directory (NAME_WE)
        # and extract the directory name (DIRECTORY) in dedicated variables.
        #
        get_filename_component(testName ${testSrc} NAME_WE)
        get_filename_component(dir ${testSrc} DIRECTORY)

        # intel compiler segfaults on cons_nonlinear, so skip these tests when compiler is intel
        if((CMAKE_CXX_COMPILER_ID MATCHES "Intel") AND (${dir} STREQUAL "cons/nonlinear"))
            continue()
        endif()


        #
        # replace forward slashes by hyphens
        #
        string(REPLACE "/" "-" dirhyphen ${dir})
        set(testName "unittest-${dirhyphen}-${testName}")

        #
        # add compile target
        #
        add_executable(${testName} src/${testSrc})

        #
        # link the executable against both criterion and the SCIP library target
        #
        target_link_libraries(${testName} ${CRITERION_LIBRARIES} libscip m)

        if(SANITIZE)
            add_sanitizers(${testName})
        endif(SANITIZE)

        #
        # use the directory name (relative to src/) to build the executable
        #
        set_target_properties(${testName} PROPERTIES
            RESOURCE_LOCK libscip
            RUNTIME_OUTPUT_DIRECTORY ${dir})
        #
        # add the newly created executable to the dependencies of the unittest target
        #
        add_dependencies(unittests ${testName})

        #
        # add a test to build this unit test
        #
        add_test(NAME ${testName}-build
                COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target ${testName}
                )

        #
        # avoid that several build jobs try to concurrently build the SCIP library
        # note that this ressource lock name is not the actual libscip target
        #
        set_tests_properties(${testName}-build
                            PROPERTIES
                                RESOURCE_LOCK libscip
                            )

        #
        # Finally, add the executable as a test to the test framework
        #
        if( COVERAGE )
            set( ADDITIONAL_FLAGS "--no-early-exit" )
        else()
            set( ADDITIONAL_FLAGS "" )
        endif()

        if(NOT ((${testName} STREQUAL "unittest-cons-nonlinear-vertexpolyhedral") AND (${LPS} STREQUAL "xprs")))
        add_test(NAME ${testName}
            COMMAND $<TARGET_FILE:${testName}> ${ADDITIONAL_FLAGS}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            )
        set_tests_properties(${testName}
                            PROPERTIES
                                DEPENDS ${testName}-build
                                RESOURCE_LOCK libscip
                            )
        endif()  # LP Error: Xpress returned 120, #3724 (LPS=xprs, unittest-cons-nonlinear-vertexpolyhedral)
    endforeach(testSrc)
endif()

=== tests/Makefile ===
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*                  This file is part of the program and library             *
#*         SCIP --- Solving Constraint Integer Programs                      *
#*                                                                           *
#*  Copyright (c) 2002-2026 Zuse Institute Berlin (ZIB)                      *
#*                                                                           *
#*  Licensed under the Apache License, Version 2.0 (the "License");          *
#*  you may not use this file except in compliance with the License.         *
#*  You may obtain a copy of the License at                                  *
#*                                                                           *
#*      http://www.apache.org/licenses/LICENSE-2.0                           *
#*                                                                           *
#*  Unless required by applicable law or agreed to in writing, software      *
#*  distributed under the License is distributed on an "AS IS" BASIS,        *
#*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
#*  See the License for the specific language governing permissions and      *
#*  limitations under the License.                                           *
#*                                                                           *
#*  You should have received a copy of the Apache-2.0 license                *
#*  along with SCIP; see the file LICENSE. If not visit scipopt.org.         *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

#@file    Makefile
#@brief   Makefile for unit tests
#@author  Felipe Serrano

#-----------------------------------------------------------------------------
# Probably nothing below here should be changed
# TODO: use the $ORIGIN variable
# NOTE: currently, compilation with SHARED=false is not supported.
# One would need to add more flags (eg $(LDFLAGS)) when linking
#-----------------------------------------------------------------------------

UNITTESTSSRC	=	$(shell find src/ -name *.c)

# remove unittests in src/bugs if BUGS is not true
ifneq ($(BUGS),true)
	UNITTESTSSRC 	:= $(filter-out $(wildcard src/bugs/*.c),$(UNITTESTSSRC))
endif

# removes `src/` prefix and file.c postfix, then sorts, which removes duplicates!
TESTDIRS 	= $(sort $(dir $(patsubst src/%,%,$(UNITTESTSSRC))))
#$(warning testdirs: $(TESTDIRS))

#-----------------------------------------------------------------------------
# paths
#-----------------------------------------------------------------------------

SCIPDIR		=	..

#-----------------------------------------------------------------------------
# SET OPTIONS FROM SCIP BINARY
#-----------------------------------------------------------------------------

ifneq ("$(wildcard $(SCIPDIR)/bin/scip)","")
# put an @ at the end of each line of scip -v to use as a marker for sed
SCIPVERSION		:=$(shell $(SCIPDIR)/bin/scip -v | sed -e 's/$$/@/')
override ARCH		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* ARCH=\([^@]*\).*/\1/')
override COMP		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* COMP=\([^@]*\).*/\1/')
override EXPRINT	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* EXPRINT=\([^@]*\).*/\1/')
override GMP		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* GMP=\([^@]*\).*/\1/')
override SYM		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* SYM=\([^@]*\).*/\1/')
override CONOPT	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* CONOPT=\([^@]*\).*/\1/')
override IPOPT		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* IPOPT=\([^@]*\).*/\1/')
override IPOPTOPT	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* IPOPTOPT=\([^@]*\).*/\1/')
override LPS		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* LPS=\([^@]*\).*/\1/')
override LPSCHECK	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* LPSCHECK=\([^@]*\).*/\1/')
override LPSOPT 	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* LPSOPT=\([^@]*\).*/\1/')
override NOBLKBUFMEM	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* NOBLKBUFMEM=\([^@]*\).*/\1/')
override NOBLKMEM	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* NOBLKMEM=\([^@]*\).*/\1/')
override NOBUFMEM	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* NOBUFMEM=\([^@]*\).*/\1/')
override OPT		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* OPT=\([^@]*\).*/\1/')
override LTO		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* LTO=\([^@]*\).*/\1/')
override OSTYPE		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* OSTYPE=\([^@]*\).*/\1/')
override THREADSAFE	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* THREADSAFE=\([^@]*\).*/\1/')
override READLINE	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* READLINE=\([^@]*\).*/\1/')
override SANITIZE	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* SANITIZE=\([^@]*\).*/\1/')
override SHARED		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* SHARED=\([^@]*\).*/\1/')
override USRARFLAGS	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* USRARFLAGS=\([^@]*\).*/\1/')
override USRCFLAGS	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* USRCFLAGS=\([^@]*\).*/\1/')
override USRCXXFLAGS	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* USRCXXFLAGS=\([^@]*\).*/\1/')
override USRFLAGS	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* USRFLAGS=\([^@]*\).*/\1/')
override USRLDFLAGS	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* USRLDFLAGS=\([^@]*\).*/\1/')
override USROFLAGS	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* USROFLAGS=\([^@]*\).*/\1/')
override VERSION	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* VERSION=\([^@]*\).*/\1/')
override ZIMPL		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* ZIMPL=\([^@]*\).*/\1/')
override ZIMPLOPT	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* ZIMPLOPT=\([^@]*\).*/\1/')
override ZLIB		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* ZLIB=\([^@]*\).*/\1/')
endif

#-----------------------------------------------------------------------------
# include default project Makefile from SCIP
#-----------------------------------------------------------------------------

include $(SCIPDIR)/make/make.project

BASESUFFIX	=	.$(BASE).$(LPS)$(EXEEXTENSION)

#-----------------------------------------------------------------------------
# Functions
#-----------------------------------------------------------------------------

src2obj		=	$(patsubst $(SRCDIR)%,$(OBJDIR)%,$(1:.c=.o))
#$(warning obj2src: src/cons/quadratic/quadratic.c -> \
	$(call src2obj, src/cons/quadratic/quadratic.c))

#-----------------------------------------------------------------------------
# Unit test definitions
#-----------------------------------------------------------------------------


BINDIRS 	= 	$(addprefix $(BINDIR)/, $(TESTDIRS))
#$(warning bindirs: $(BINDIRS))

OBJDIRS 	= 	$(addprefix $(OBJDIR)/, $(TESTDIRS))
#$(warning objdirs: $(OBJDIRS))

# remove the .c from UNITTESTSSRC: src/lpi/bases, src/cons/quadratic/gauge, etc
UNITTESTS 	= 	$(basename $(UNITTESTSSRC))
#$(warning unittests: $(UNITTESTS))

# build object files from source files: obj/O.linux.../cons/expr/free.o, etc
UNITTESTSOBJ 	= 	$(call src2obj, $(UNITTESTSSRC))
#$(warning unittestobj: $(UNITTESTSOBJ))

# build dependency files from object files: obj/O.linux.../cons/expr/free.d, etc
UNITTESTSDEP 	= 	$(UNITTESTSOBJ:.o=.d)
#$(warning unittestdep: $(UNITTESTSDEP))

# substitute src/ for $(OBJDIR) and append $(BASESUFFIX) to UNITTESTS: bin/cons/expr/free.linux..., etc
UNITTESTSBIN 	= 	$(addsuffix $(BASESUFFIX), $(patsubst $(SRCDIR)%,$(BINDIR)%,$(UNITTESTS)))
#$(warning unittestsbin: $(UNITTESTSBIN))

UNITTESTSEXECS	=	$(addsuffix $(BASESUFFIX), $(UNITTESTS))

#-----------------------------------------------------------------------------
# Flags
# filter out some flags to make criterion compile without warnings with gcc
# and make the tests run with clang.
# TODO: in newer version, check if we still need this
#-----------------------------------------------------------------------------

CFLAGS 		:=	$(filter-out -Wdeclaration-after-statement -Wstrict-prototypes, $(CFLAGS))
ifeq ($(COMP), clang)
CFLAGS 		:=	$(filter-out -Wcast-align, $(CFLAGS))
endif
CFLAGS 		+=	-std=c99
# to find include/scip_test.h
FLAGS 		+= 	-I.

#-----------------------------------------------------------------------------
# Criterion Framework
#-----------------------------------------------------------------------------
CR_INC		=	$(wildcard Criterion/include)
CR_LIBDIR	=	$(wildcard Criterion/lib)
CR_LIB		=	criterion

#-----------------------------------------------------------------------------
# Rules
# Small remainder:
# $@ refers to the target
# $^ refers to all the dependencies
# $< refers to all the first dependency
# $? refers to the dependencies that are newer than the target
# Newer dependencies are one reason why a rule is executed.
#-----------------------------------------------------------------------------

ifeq ($(VERBOSE),false)
.SILENT:	$(UNITTESTSBIN) $(UNITTESTSOBJ)
endif

# Disable ASLR (address space layout randomization) on Linux via setarch -R
# as this is not compatible with Criterions parametrized tests (https://github.com/Snaipe/Criterion/issues/208)
ifeq ($(OSTYPE),linux)
DISABLE_ASLR := setarch `uname -m` -R
endif

.PHONY: all
all:            Criterion $(OBJDIR) $(OBJDIRS) $(BINDIRS) $(UNITTESTSBIN)
		make ctestrunner
		$(DISABLE_ASLR) ctest --output-on-failure $(if $(FILTER), -R $(FILTER))

.PHONY: lint
lint:		$(UNITTESTSSRC)
		-rm -f lint.out
		$(SHELL) -ec 'for i in $^; \
			do \
			echo $$i; \
			$(LINT) $(SCIPDIR)/lint/scip.lnt +os\(lint.out\) -u -zero \
			$(FLAGS) -UNDEBUG -USCIP_WITH_READLINE -USCIP_ROUNDING_FE $$i; \
			done'

$(OBJDIR):
		@echo "-> Creating $@ directory"
		@-mkdir -p $@
$(OBJDIRS):
		@echo "-> Creating $@ directory"
		@-mkdir -p $@
$(BINDIRS):
		@echo "-> Creating $@ directory"
		@-mkdir -p $@

.PHONY: test
test:           $(UNITTESTSBIN)
		make ctestrunner
		$(DISABLE_ASLR) ctest --output-on-failure $(if $(FILTER), -R $(FILTER))

.PHONY: ctestrunner
ctestrunner: 	$(UNITTESTSBIN)
		@echo -e "#Automatic generated file\n" > "CTestTestfile.cmake"
		@echo -e $(foreach bin,$(UNITTESTSBIN), \
			"ADD_TEST($(shell echo $(bin:$(BASESUFFIX)=) | sed s/^bin/test/g | sed s/\\//_/g) $(bin))\n" >> "CTestTestfile.cmake")

.PHONY: clean
clean:
		@echo "-> remove main object files"
		$(foreach dir, $(OBJDIRS) $(OBJDIR), \
			@-rm -f $(dir)/*.o $(dir)/*.d)
		@echo "-> remove binaries"
		$(foreach bin, $(UNITTESTSBIN), \
			@-rm -f $(bin))

.PHONY: tags
tags:
		rm -f TAGS; ctags -e src/*.c src/*.h $(SCIPDIR)/src/scip/*.c $(SCIPDIR)/src/scip/*.h;

.PHONY: depend
depend:		$(SCIPDIR)
		@- rm -f $(UNITTESTSDEP)
		$(foreach src, $(UNITTESTSSRC), \
			$(SHELL) -ec '$(DCC) $(FLAGS) $(src) \
			$(DFLAGS) $(call src2obj, $(src))' >> $(UNITTESTSDEP);)



-include	$(UNITTESTSDEP)


$(BINDIR)/%$(BASESUFFIX): $(OBJDIR)/%.o $(SCIPLIBFILE) $(LPILIBFILE) $(TPILIBFILE)
		@echo "-> linking $@"
		$(LINKCXX) $< $(LINKCXXSCIPALL) \
		$(LINKCXX_l)$(TPILIB) \
		$(addprefix $(LINKCXX_L),$(CR_LIBDIR)) \
		$(LINKCXX_l)$(CR_LIB) \
		$(LINKRPATH)$(realpath $(SCIPDIR)/lib/shared) \
		$(addprefix $(LINKRPATH),$(realpath $(CR_LIBDIR))) \
		$(SANITIZERFLAGS) \
		$(LINKCXX_o)$@

$(LPILIBFILE):
		$(error $@ not available. SCIP must be compiled with OPT=$(OPT) SHARED=$(SHARED) LPS=$(LPS))
$(SCIPLIBFILE):
		$(error $@ not available. SCIP must be compiled with OPT=$(OPT) SHARED=$(SHARED))
$(TPILIBFILE):
		$(error $@ not available. SCIP must be compiled with OPT=$(OPT) SHARED=$(SHARED) TPI=$(TPI))

-include	$(UNITTESTSDEP)

$(OBJDIR)/%.o : $(SRCDIR)/%.c | $(OBJDIR) $(OBJDIRS) $(BINDIRS)
		@echo "-> compiling $@"
		$(CC) $(addprefix -I,$(CR_INC)) $(FLAGS) $(OFLAGS) $(BINOFLAGS) $(CFLAGS) $(DFLAGS) -c $< $(CC_o)$@

$(OBJDIR)/%.o:	%.cpp
		@echo "-> compiling $@"

=== applications/Coloring/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

# INTERPROCEDURAL_OPTIMIZATION is enforced when enabled.
if(POLICY CMP0069)
   cmake_policy(SET CMP0069 NEW)
endif()

project(Coloring)

if(TARGET SCIP::SCIP)
  # find package by SCIP PATH
  find_package(SCIP CONFIG NO_DEFAULT_PATH PATHS ${SCIP_BINARY_DIR} REQUIRED)
else()
  find_package(SCIP REQUIRED)
endif()

include_directories(BEFORE PUBLIC ${SCIP_INCLUDE_DIRS})

add_executable(coloring
    src/branch_coloring.c
    src/branch_strongcoloring.c
    src/coloringplugins.c
    src/cons_storeGraph.c
    src/heur_init.c
    src/main.c
    src/pricer_coloring.c
    src/probdata_coloring.c
    src/reader_col.c
    src/reader_csol.c
)
set_property(TARGET coloring PROPERTY INTERPROCEDURAL_OPTIMIZATION ${LTO_AVAILABLE})

# link to math library if it is available
find_library(LIBM m)
if(NOT LIBM)
  set(LIBM "")
endif()

target_link_libraries(coloring ${SCIP_LIBRARIES} ${LIBM})
target_compile_options(coloring PRIVATE ${SCIP_COMPILE_FLAGS})

if( TARGET applications )
    add_dependencies( applications coloring )
endif()

add_subdirectory(check)

enable_testing()

=== applications/Coloring/Makefile ===
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*                  This file is part of the program and library             *
#*         SCIP --- Solving Constraint Integer Programs                      *
#*                                                                           *
#*  Copyright (c) 2002-2026 Zuse Institute Berlin (ZIB)                      *
#*                                                                           *
#*  Licensed under the Apache License, Version 2.0 (the "License");          *
#*  you may not use this file except in compliance with the License.         *
#*  You may obtain a copy of the License at                                  *
#*                                                                           *
#*      http://www.apache.org/licenses/LICENSE-2.0                           *
#*                                                                           *
#*  Unless required by applicable law or agreed to in writing, software      *
#*  distributed under the License is distributed on an "AS IS" BASIS,        *
#*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *
#*  See the License for the specific language governing permissions and      *
#*  limitations under the License.                                           *
#*                                                                           *
#*  You should have received a copy of the Apache-2.0 license                *
#*  along with SCIP; see the file LICENSE. If not visit scipopt.org.         *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

#@file    Makefile
#@brief   Makefile for C Coloring application using SCIP as a callable library
#@author  Thorsten Koch
#@author  Tobias Achterberg
#@author  Marc Pfetsch
#@author  Gerald Gamrath


#-----------------------------------------------------------------------------
# paths
#-----------------------------------------------------------------------------

SCIPDIR         =       ../..


#-----------------------------------------------------------------------------
# include default project Makefile from SCIP (need to do this twice, once to
# find the correct binary, then, after getting the correct flags from the
# binary (which is necessary since the ZIMPL flags differ from the default
# if compiled with the SCIP Optsuite instead of SCIP), we need to set the
# compile flags, e.g., for the ZIMPL library, which is again done in make.project
#-----------------------------------------------------------------------------
include $(SCIPDIR)/make/make.project
SCIPVERSION			:=$(shell $(SCIPDIR)/bin/scip.$(BASE).$(LPS).$(TPI)$(EXEEXTENSION) -v | sed -e 's/$$/@/')
override ARCH		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* ARCH=\([^@]*\).*/\1/')
override EXPRINT	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* EXPRINT=\([^@]*\).*/\1/')
override GMP		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* GMP=\([^@]*\).*/\1/')
override SYM		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* SYM=\([^@]*\).*/\1/')
override IPOPT		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* IPOPT=\([^@]*\).*/\1/')
override IPOPTOPT	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* IPOPTOPT=\([^@]*\).*/\1/')
override CONOPT	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* CONOPT=\([^@]*\).*/\1/')
override LPSCHECK	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* LPSCHECK=\([^@]*\).*/\1/')
override LPSOPT 	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* LPSOPT=\([^@]*\).*/\1/')
override NOBLKBUFMEM	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* NOBLKBUFMEM=\([^@]*\).*/\1/')
override NOBLKMEM	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* NOBLKMEM=\([^@]*\).*/\1/')
override NOBUFMEM	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* NOBUFMEM=\([^@]*\).*/\1/')
override THREADSAFE	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* THREADSAFE=\([^@]*\).*/\1/')
override READLINE	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* READLINE=\([^@]*\).*/\1/')
override SANITIZE	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* SANITIZE=\([^@]*\).*/\1/')
override ZIMPL		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* ZIMPL=\([^@]*\).*/\1/')
override ZIMPLOPT	:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* ZIMPLOPT=\([^@]*\).*/\1/')
override ZLIB		:=$(shell echo "$(SCIPVERSION)" | sed -e 's/.* ZLIB=\([^@]*\).*/\1/')
include $(SCIPDIR)/make/make.project




#-----------------------------------------------------------------------------
# Main Program
#-----------------------------------------------------------------------------

MAINNAME	=	coloring
MAINOBJ		=	reader_col.o \
			reader_csol.o \
			probdata_coloring.o \
			pricer_coloring.o \
			cons_storeGraph.o \
			branch_coloring.o \
			branch_strongcoloring.o \
			heur_init.o \
			coloringplugins.o \
			main.o

MAINSRC		=	$(addprefix $(SRCDIR)/,$(MAINOBJ:.o=.c))

MAIN		=	$(MAINNAME).$(BASE).$(LPS)$(EXEEXTENSION)
MAINFILE	=	$(BINDIR)/$(MAIN)
MAINSHORTLINK	=	$(BINDIR)/$(MAINNAME)
MAINOBJFILES	=	$(addprefix $(OBJDIR)/,$(MAINOBJ))


#-----------------------------------------------------------------------------
# Rules
#-----------------------------------------------------------------------------

ifeq ($(VERBOSE),false)
.SILENT:	$(MAINFILE) $(MAINOBJFILES) $(MAINSHORTLINK)
endif

.PHONY: all
all:            $(SCIPDIR) $(MAINFILE) $(MAINSHORTLINK)

.PHONY: lint
lint:		$(MAINSRC)
		-rm -f lint.out
		$(SHELL) -ec 'for i in $^; \
			do \
			echo $$i; \
			$(LINT) -I$(SCIPDIR) lint/main-gcc.lnt +os\(lint.out\) -u -zero \
			$(FLAGS) -UNDEBUG -USCIP_WITH_READLINE -USCIP_ROUNDING_FE $$i; \
			done'

.PHONY: pclint
pclint:		$(MAINSRC)
		-rm -f pclint.out
ifeq ($(FILES),)
		@$(SHELL) -ec 'echo "-> running pclint on $^..."; \
			$(PCLINT) -I$(SCIPDIR) -I$(SCIPDIR)/pclint main-gcc.lnt +os\(pclint.out\) -u -zero -max_threads=$(MAXJOBS) \
			$(USRFLAGS) $(FLAGS) -uNDEBUG -uSCIP_WITH_READLINE -uSCIP_ROUNDING_FE -D_BSD_SOURCE $^;'
else
		@$(SHELL) -ec  'echo "-> running pclint on files $(FILES) ..."; \
			$(PCLINT) -I$(SCIPDIR) -I$(SCIPDIR)/pclint main-gcc.lnt +os\(pclint.out\) -u -zero -max_threads=$(MAXJOBS) \
			$(USRFLAGS) $(FLAGS) -uNDEBUG -uSCIP_WITH_READLINE -uSCIP_ROUNDING_FE -D_BSD_SOURCE $(FILES);'
endif

.PHONY: scip
scip:
		@$(MAKE) -C $(SCIPDIR) libs $^

.PHONY: doc
doc:
		@-(cd doc && ln -fs ../$(SCIPDIR)/doc/pictures/scippy.png);
		@-(cd doc && ln -fs ../$(SCIPDIR)/doc/pictures/miniscippy.png);
		@-(cd doc && ln -fs ../$(SCIPDIR)/doc/scipfooter.html footer.html);
		cd doc; $(DOXY) $(MAINNAME).dxy

$(MAINSHORTLINK):	$(MAINFILE)
		@rm -f $@
		cd $(dir $@) && ln -s $(notdir $(MAINFILE)) $(notdir $@)

$(OBJDIR):
		@-mkdir -p $(OBJDIR)

$(BINDIR):
		@-mkdir -p $(BINDIR)

.PHONY: test
test:           $(MAINFILE)
		@-(cd check && ln -fs ../$(SCIPDIR)/check/check.sh);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/evaluate.sh);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/evalcheck.sh);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/evalcheck_cluster.sh);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/check.awk);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/getlastprob.awk);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/configuration_set.sh);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/configuration_solufile.sh);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/configuration_logfiles.sh);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/configuration_tmpfile_setup_scip.sh);
		@-(cd check && ln -fs ../$(SCIPDIR)/check/run.sh);
		cd check; \
		$(SHELL) ./check.sh $(TEST) $(EXECUTABLE) $(SETTINGS) $(BINID) $(OUTPUTDIR) $(TIME) $(NODES) $(MEM) $(THREADS) $(FEASTOL) $(DISPFREQ) \
			$(CONTINUE) $(LOCK) "example" $(LPS) $(DEBUGTOOL) $(CLIENTTMPDIR) $(REOPT) $(OPTCOMMAND) $(SETCUTOFF) $(MAXJOBS) $(VISUALIZE) $(PERMUTE) \
			$(SEEDS) $(GLBSEEDSHIFT) $(STARTPERM) $(PYTHON) $(EMPHBENCHMARK) $(CLOCKTYPE);

.PHONY: clean
clean:		$(OBJDIR)
ifneq ($(OBJDIR),)
		@-(rm -f $(OBJDIR)/*.o $(OBJDIR)/*.d && rmdir $(OBJDIR));
		@echo "-> remove main objective files"
endif
		@-rm -f $(MAINFILE) $(MAINSHORTLINK)
		@echo "-> remove binary"

.PHONY: tags
tags:
		rm -f TAGS; ctags -e src/*.c src/*.h $(SCIPDIR)/src/scip/*.c $(SCIPDIR)/src/scip/*.h;

-include	$(MAINOBJFILES:.o=.d)

$(MAINFILE):	$(BINDIR) $(OBJDIR) $(SCIPLIBFILE) $(LPILIBFILE) $(MAINOBJFILES)
		@echo "-> linking $@"
		$(LINKCXX) $(MAINOBJFILES) $(LINKCXXSCIPALL) $(LDFLAGS) $(LINKCXX_o)$@

$(OBJDIR)/%.o:	$(SRCDIR)/%.c
		@echo "-> compiling $@"
		$(CC) $(FLAGS) $(OFLAGS) $(BINOFLAGS) $(CFLAGS) $(DFLAGS) -c $< $(CC_o)$@

$(OBJDIR)/%.o:	$(SRCDIR)/%.cpp
		@echo "-> compiling $@"
		$(CXX) $(FLAGS) $(OFLAGS) $(BINOFLAGS) $(CXXFLAGS) $(DFLAGS) -c $< $(CXX_o)$@

#---- EOF --------------------------------------------------------------------

=== applications/CycleClustering/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

# INTERPROCEDURAL_OPTIMIZATION is enforced when enabled.
if(POLICY CMP0069)
   cmake_policy(SET CMP0069 NEW)
endif()

project(CycleClustering)

if(TARGET SCIP::SCIP)
  # find package by SCIP PATH
  find_package(SCIP CONFIG NO_DEFAULT_PATH PATHS ${SCIP_BINARY_DIR} REQUIRED)
else()
  find_package(SCIP REQUIRED)
endif()

include_directories(BEFORE PUBLIC ${SCIP_INCLUDE_DIRS})

add_executable(cycleclustering
    src/main.c
    src/cycplugins.c
    src/sepa_partition.c
    src/sepa_edge.c
    src/sepa_subtour.c
    src/heur_cycgreedy.c
    src/heur_fuzzyround.c
    src/heur_cyckerlin.c
    src/heur_redsize.c
    src/branch_multinode.c
    src/event_newsol.c
    src/reader_cyc.c
    src/probdata_cyc.c
)
set_property(TARGET cycleclustering PROPERTY INTERPROCEDURAL_OPTIMIZATION ${LTO_AVAILABLE})

# link to math library if it is available
find_library(LIBM m)
if(NOT LIBM)
  set(LIBM "")
endif()

target_link_libraries(cycleclustering ${SCIP_LIBRARIES} ${LIBM})
target_compile_options(cycleclustering PRIVATE ${SCIP_COMPILE_FLAGS})

if( TARGET applications )
    add_dependencies( applications cycleclustering)
endif()

add_subdirectory(check)

enable_testing()

=== debian/changelog ===
scip (10.0.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Source-only upload for transition to testing.
  * debian/control
    - Add libzimpl-dev and zimpl to Build-Depends.
  * debian/copyright
    - Update upstream copyright years.
  * debian/libscip10.0.symbols
    - Remove file; too difficult to maintain.
  * debian/rules
    - Build with zimpl support.
  * debian/tests/CTestTestfile.cmake
    - Add zimpl tests.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 25 Feb 2026 22:45:19 -0500

=== debian/control ===
Source: scip
Section: math
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: cmake,
               coinor-libipopt-dev,
               debhelper-compat (= 13),
               gfortran,
               help2man,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libgmp-dev,
               libmpfr-dev,
               libnauty-dev,
               libpapilo-dev,
               libreadline-dev,
               libsoplex-dev,
               libz-dev,
               libzimpl-dev,
               pkgconf,
               zimpl
Build-Depends-Indep: doxygen, python3-minimal
Standards-Version: 4.7.3
Homepage: https://scipopt.org/
Vcs-Browser: https://salsa.debian.org/math-team/scip
Vcs-Git: https://salsa.debian.org/math-team/scip.git

Package: scip
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: scip-doc
Description: Solving Constraint Integer Programs (command line tool)
 SCIP is currently one of the fastest non-commercial solvers for mixed
 integer programming (MIP) and mixed integer nonlinear programming
 (MINLP). It is also a framework for constraint integer programming and
 branch-cut-and-price. It allows for total control of the solution
 process and the access of detailed information down to the guts of the
 solver.  By default, SCIP comes with a bouquet of different plugins
 for solving MIPs and MINLPs.
 .
 This package contains the SCIP command line tool.

Package: libscip10.0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Solving Constraint Integer Programs (shared libraries)
 SCIP is currently one of the fastest non-commercial solvers for mixed
 integer programming (MIP) and mixed integer nonlinear programming
 (MINLP). It is also a framework for constraint integer programming and
 branch-cut-and-price. It allows for total control of the solution
 process and the access of detailed information down to the guts of the
 solver.  By default, SCIP comes with a bouquet of different plugins
 for solving MIPs and MINLPs.
 .
 This package contains the SCIP shared libraries.

Package: libscip-dev
Section: libdevel
Architecture: any
Depends: libscip10.0 (=${binary:Version}), ${misc:Depends}
Recommends: scip-doc
Description: Solving Constraint Integer Programs (development files)
 SCIP is currently one of the fastest non-commercial solvers for mixed
 integer programming (MIP) and mixed integer nonlinear programming
 (MINLP). It is also a framework for constraint integer programming and
 branch-cut-and-price. It allows for total control of the solution
 process and the access of detailed information down to the guts of the
 solver.  By default, SCIP comes with a bouquet of different plugins
 for solving MIPs and MINLPs.
 .
 This package contains the development files for the SCIP library.

Package: scip-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Solving Constraint Integer Programs (documentation)
 SCIP is currently one of the fastest non-commercial solvers for mixed
 integer programming (MIP) and mixed integer nonlinear programming
 (MINLP). It is also a framework for constraint integer programming and
 branch-cut-and-price. It allows for total control of the solution
 process and the access of detailed information down to the guts of the
 solver.  By default, SCIP comes with a bouquet of different plugins
 for solving MIPs and MINLPs.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk # for DEB_HOST_GNU_TYPE

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --               \
		-DCMAKE_BUILD_TYPE=Release \
		-DAMPL=OFF                 \
		-DEXPRINT=none             \
		-DSYM=nauty                \
		-DZIMPL=ON

execute_before_dh_auto_build: src/scip/githash.c

# not in git repository; update this at each release
src/scip/githash.c:
	echo "#define SCIP_GITHASH \"76a50c97d6\"" > $@

execute_after_dh_auto_build-indep:
	cd obj-$(DEB_HOST_GNU_TYPE) && $(MAKE) doc

execute_before_dh_installman: debian/scip.1

debian/scip.1:
	help2man -N -o $@ -n "Solving Constraint Integer Programs" \
		debian/tmp/usr/bin/scip
	sed -i '/^invalid parameter <\\-\\-help>$$/ { N; /\n\.PP$$/d }' $@
	sed -i 's|debian/tmp/usr/bin/||' $@

override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && $(MAKE) check

# generate test file for autopkgtest; update this at each release
debian/tests/CTestTestfile.cmake: obj-$(DEB_HOST_GNU_TYPE)/check/CTestTestfile.cmake
	cp $< $@
	sed -i '/default/!d' $@
	sed -i '/Objlim/d' $@ # only fails in autopkgtest, not during build (why?)
	sed -i 's/DEPENDS "scip-build" //g' $@
	sed -i 's/ _BACKTRACE_TRIPLES "[^"]*"//g' $@
	sed -i 's|"[^"]*/bin/scip|"/usr/bin/scip|g' $@
	sed -Ei 's|(["<])[^"<]*/check|\1@BUILDDIR@/check|g' $@

=== debian/tests/control ===
Test-Command: cp debian/tests/CTestTestfile.cmake $AUTOPKGTEST_TMP &&
	      sed -i "s|@BUILDDIR@|$(pwd)|g" $AUTOPKGTEST_TMP/CTestTestfile.cmake &&
	      ctest --test-dir $AUTOPKGTEST_TMP
Depends: scip, cmake

=== debian/watch ===
version=4
# we assume that 3-digit tags need dots, e.g., v924 -> 9.2.4
opts=uversionmangle=s/^([0-9])([0-9])([0-9])$/$1.$2.$3/,\
repacksuffix=+ds,dversionmangle=auto,repack \
https://github.com/scipopt/scip/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
